package com.scbfkj.uni.service;

import com.scbfkj.uni.library.DataFormatUtil;
import com.scbfkj.uni.library.UniReturnUtil;
import com.scbfkj.uni.process.DataBase;
import com.scbfkj.uni.system.Config;

import java.io.File;
import java.util.Collections;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

public class LoggerService {

    private static final String connection = """
            {
              "jdbcUrl": "jdbc:sqlite:%s",
              "driverClassName": "org.sqlite.JDBC",
              "enableCache":false
            }
            """;

    private final static Set<Long> fileNames = new HashSet<>();
    private static final String dbFileName = "logs/%s.sqlite";

    public static void log(String target, Map<String, Object> data) {
        long filename = System.currentTimeMillis() / Config.splitCount;

        String filePath = dbFileName.formatted( filename);
        String connectionStr = connection.formatted(filePath);
        synchronized (fileNames) {
            if (!fileNames.contains(filename)) {
                if (!new File(filePath).exists()) {
                    try {
                        DataBase.exec(connectionStr, """
                                create table logs
                                (
                                    logid         Integer
                                        primary key autoincrement,
                                    target     TEXT,
                                    datacontent      TEXT
                                )""");
                    } catch (Exception e) {
                        System.out.println(UniReturnUtil.getMessage(e));
                    }
                }
                fileNames.add(filename);
                fileNames.removeIf(it -> it + 1000 < filename);
            }
        }
        try {
            DataBase.updateBatch(connectionStr, "insert into logs (target,datacontent) values(?,?)", Collections.singletonList(new Object[]{target, DataFormatUtil.toString(data)}));
        } catch (Exception e) {
            System.out.println(UniReturnUtil.getMessage(e));
        }
    }
}
